import os
import pandas as pd
import matplotlib.pyplot as plt
import datetime
import numpy as np

BASEPATH = # insert your data file path here
ORIGINAL = BASEPATH + 'original/'
PROCESSED = BASEPATH + 'processed/'

# Loading the .csv file with the original dataset
df = pd.read_csv(ORIGINAL + 'covid_merged.csv')

# Drop columns that are not of interest

df = df.drop(['Status', 'UserLanguage', 'Finished', 'Duration__in_seconds_', 'UserLanguage',
             'sexuality', 'sexualityO', 'maritalstatus', 'parent', 'edu', 'employ', 'zipcode', 'occupation',
             'income', 'accom', 'living', 'covidpos', 'covidstatus', 'height', 'weight', 'diagnosis', 'health13',
             'health14', 'health15', 'health16', 'health17',
             'health18','health19', 'healthF1', 'healthF2', 'healthF3', 'healthF4', 'healthF5', 'healthF6',
             'healthF7', 'healthF8','healthF9', 'healthF10', 'healthF11', 'healthF12', 'healthF13', 'healthF14',
             'healthF15', 'healthF16', 'healthF17', 'healthF18','healthF19', 'healthF20', 'isolatedays', 'isolate',
             'isolate1', 'isolate2', 'isolate3', 'isolate4', 'isolate5', 'isolate6', 'isolate7', 'isolate8', 'mask',
             'maskperc', 'qual1', 'qual2', 'site','PHQ1','PHQ2','PHQ3','PHQ4','PHQ5','PHQ6','PHQ7','PHQ8','PHQ9',
             'GAD1','GAD2','GAD3','GAD4','GAD5','GAD6','CASES1','CASES2','CASES3','CASES4','CASES5','CASES6',
             'CASES7','CASES8','CASES9','CASES10','CASES11','CASES12','CASES13','CASES14','CASES15','CASES16','CASES17',
             'CASES18','CASES19','CASES20','CASES21','CASES22','CASES23','CASES24','CASES25','CASES26','CASES27',
             'CASES28','CASES29','CASES30','Lone2','Lone3','Lone4','Lone7','Lone8','Lone11','Lone12','Lone13','Lone14',
             'Lone17','Lone18','Lone1r','Lone5r','Lone6r','Lone9r','Lone10r','Lone15r','Lone16r','Lone19r','Lone20r',
             'CHAOS2','CHAOS3','CHAOS4','CHAOS1r','CHAOS5r','CHAOS6r','Sleep2','Sleep3','Sleep4','Sleep5','Sleep6',
             'Sleep1r','Sleep7r','StressLTot', 'AlcPre1','TobPre1','DrugPre1','CannabisPre1','AlcPost1','TobPost1',
             'DrugPost1','CannabisPost1','AlcDiff','TobDiff','DrugDiff','CannabisDiff','isolatedaysR','SpaceTot',
             'gender2','spq2285','spqPAR85', 'proactive','reactive', 'genderO','ethinicity','ethnicID','Garden',
             'Balcony','Green','Rooms','HouseTot','Partner','MotherStepM','FatherStepF','ChildStepChild','SibStepSibs',
             'Grandparents','Pets','Other','Othertext','covidhouse','AlcPre','TobPre','DrugPre','CannabisPre','AlcPost',
             'TobPost','DrugPost','CannabisPost','AlcNA','TobNA','DrugNA','CannabisNA','GADPHQ1','GADPHQ2','GADPHQ', 'Stress1',
             'Stress2', 'Stress3', 'Stress4', 'Stress5', 'Stress6', 'Stress7', 'Stress8', 'Stress9', 'Stress10', 'Stress11',
             'Stress12', 'Stress13', 'Stress14', 'Stress15', 'Stress16', 'Stress17', 'Stress18', 'Stress19', 'Stress20',
             'Stress21', 'Stress22', 'Stress23', 'Stress24', 'Stress25', 'Stress26','CovidNews', 'Belief1','Belief2',
             'Belief3','Belief4','Belief5','Belief6','Belief7','Belief8','Belief9', 'spqPAR','SMStot'], axis = 1)

# Convert names of variables
df.rename(columns={'gender':'Gender',
                   'age_years': 'age_year',
                   'CHAOSrtot': 'CHAOStot'}, inplace=True)

"""# VALUE FIX

### PHYSICAL ACTIVITY (TIME)
"""

# Compute minutes of physical activity a week
myDict = {
 ' 0':   0,
 ' 30':   30,
 ' 45':   45,
 ' 60':   60,
 '&lt;120 minutes':   120,
 '-':   np.nan,
 '-99':   np.nan,
 '-99.0':   np.nan,
 '0':   0,
 '0 days': 0  ,
 '0 λεπτά': 0  ,
 "30'":  30 ,
 "0'":   0,
 "5'":  5 ,
 '0.0': 0  ,
 '0.3':  20 ,
 '0.5小时': 30,
 '00':  0 ,
 '1':   1,
 '1 1/2': 90  ,
 '1,2h': 72,
 '1 heure': 60  ,
 '1 hour':  60 ,
 '1 hr':   60,
 '1 hr.':   60,
 '1 ora':   60,
 '1 ora e 30 minuti':   90,
 '1 ώρα':   60,
 '1':   1,
 "2h'":   120,
 '1-2':   90,
 '1-2h':   90,
 '1-4h':   150,
 '1.5':   90,
 '1.5 hours':  90,
 '10':   10,
 '10 min': 10  ,
 '100':  100 ,
 '118':   118,
 '120':  120 ,
 '120.0':   120,
 '1200':   1200,
 '120min':   120,
 '13':   13,
 '130':   130,
 '140':   140,
 '15':  15 ,
 '15 min': 15  ,
 '15 mins':  15 ,
 '15 minutes': 15  ,
 '15-30':   22,
 '150':   150,
 '155':  155 ,
 '16':   16,
 '160':   160,
 '180':   180,
 '190':   190,
 '1h':   60,
 '1h30':  90 ,
 '1hr':   60,
 '1小時':   60,
 '2':   120,
 '2 hours': 120,
 '2 hr':   120,
 '20':   20,
 '20 min':  20,
 "20'":   20,
 '20-30':  25 ,
 '20.0':  20,
 '20/30': 25,
 '200': 200,
 '20min': 20,
 '210': 210,
 '2280':  np.nan,
 '24': 24,
 '240': 240,
 '25': 25,
 '250': 250,
 '260': 260,
 '2h': 120,
 '2hours':  120,
 '2hrs':  120,
 '2hrs + a day':  120,
 '2p': np.nan,
 '3':   3,
 '3 hours':   180,
 '3 hr':   180,
 '30':   30,
 '30 min':  30,
 '30 mins':  30,
 '30 minutes': 30,
 "30'":  30,
 '30-40':  35,
 '30-45':  37,
 '30-60':   45,
 '30-60min':  45 ,
 '30-90':  60,
 '30.0':  30,
 '30/60':   45,
 '300':   300,
 '30e':   np.nan,
 '30min':   30,
 '30mins':   30,
 '30minutes':   30,
 '30’':   30,
 '320':   320,
 '35':   35,
 '35-50’': 42,
 '360':  360,
 '390':   390,
 '3heures':  180,
 '3小時':  180,
 '4':  4,
 '4 hours': 240,
 '40':  40,
 '40 min':  40,
 '40 mins':  40,
 '40.0':  40,
 '400':   400,
 '40min':   40,
 '420':   420,
 '44':   44,
 '45':   45,
 '45 min':  45 ,
 '45 mins':   45,
 '45-60':   52,
 '45.0':   45,
 '46':   46,
 '460':   460,
 '480': 480,
 '4hrs': 240,
 '5': 5,
 '5 days': np.nan,
 '5 hrs': 300,
 '50': 50,
 '50-60': 55,
 '500': 500,
 '55': 55,
 '55 minutes': 55,
 '5h': 300,
 '6': 6,
 '60': 60,
 '60 min': 60,
 '60 mins': 60,
 '60 minutes': 60,
 "60'": 60,
 '60-120': 90,
 '60-80': 70,
 '60-90': 75,
 '60.0': 60,
 '600': 600,
 '603': 603,
 '60min': 60,
 '7': 7,
 '7 hours': 420,
 '70': 70,
 '720': 720,
 '75': 75,
 '78': 78,
 '8': 8,
 '8 ore': 480,
 '80':  80,
 '800': 800,
 '89': 89,
 '9': 9,
 '90': 90,
 '90.0': 90,
 '95': 95,
 'Half hour': 30,
 'Hi': np.nan,
 'Hour': 60,
 'Na': np.nan,
 'None': np.nan,
 'O': np.nan,
 'W0':  np.nan,
 'an hour': 60,
 'approx 60-90': 75,
 'half an hour': 30,
 'nan': np.nan,
 'none': np.nan,
 'Μισή ώρα': 30,
 '没有': np.nan,
 '-99.0': np.nan,
 '0': 0,
 '0,30': 20,
 '0,5': 30,
 '0.0': 0,
 '1': 1,
 '1,2h': 90,
 '1.0': 1,
 '10': 10,
 '10.0': 10,
 '100': 100,
 '100.0': 100,
 '118': 118,
 '120': 120,
 '120.0': 120,
 '1200': 1200,
 '13': 13,
 '13.0': 13,
 '130': 130,
 '130.0': 130,
 '140': 140,
 '140.0': 140,
 '15': 15,
 '15.0': 15,
 '150':150,
 '150.0': 150,
 '155.0': 155,
 '16': 16,
 '160': 160,
 '180': 180,
 '180.0': 180,
 '190': 190,
 '20': 20,
 '20.0': 20,
 '200': 200,
 '200.0': 200,
 '210.0': 210,
 '22': 22,
 '2280': 2280,
 '24': 24,
 '240': 240,
 '240.0': 240,
 '25': 25,
 '25.0': 25,
 '250': 250,
 '250.0': 250,
 '260': 260,
 '3': 3,
 '3.0': 3,
 '30': 30,
 '30.0': 30,
 '300': 300,
 '300.0': 300,
 '320': 320,
 '35': 35,
 '35.0': 35,
 '360': 360,
 '360.0': 360,
 '37': 37,
 '390': 390,
 '4': 4,
 '4.0': 4,
 '40': 40,
 '40.0': 40,
 '400': 400,
 '400.0': 400,
 '42.0': 42,
 '420': 420,
 '44.0': 44,
 '45': 45,
 '45.0': 45,
 '46.0': 46,
 '460': 460,
 '480': 480,
 '480.0': 480,
 '5': 5,
 '5.0': 5,
 '50': 50,
 '50.0': 50,
 '500': 500,
 '500.0': 500,
 '52': 52,
 '52.0': 52,
 '55': 55,
 '55.0': 55,
 '6': 6,
 '60': 60,
 '60.0': 60,
 '600': 600,
 '603': 603,
 '7': 7,
 '7.0': 7,
 '70': 70,
 '70.0': 70,
 '720': 720,
 '720.0': 720,
 '75': 75,
 '75.0': 75,
 '78': 78,
 '78.0': 78,
 '8': 8,
 '80': 80,
 '80.0':80,
 '800':800,
 '800.0':800,
 '89':89,
 '89.0':89,
 '9.0':9,
 '90':90,
 '90.0':90,
 '95.0':95,
 'nan': np.nan}

# Replace values in the variables
for c in ['VigPhyAct_TimePost', 'ModPhyAct_TimePost', 'MildPhyAct_TimePost', 'VigPhyAct_Time', 'ModPhyAct_Time', 'MildPhyAct_Time']:
    df[c] = df[c].replace(myDict)

"""### ACTIVITY"""

# Converte ActTime columns into float
for column in ['VigPhyAct_TimePost', 'VigPhyAct_Time', 'ModPhyAct_TimePost', 'ModPhyAct_Time', 'MildPhyAct_TimePost', 'MildPhyAct_Time']:
    df[column] = df[column].astype(float)

# Compute ActTimeDiff (differences Post-Pre COVID in time spent in vigorous, moderate, and mild physical activity)
df['VigActTimeDiff'] = df['VigPhyAct_TimePost'] - df['VigPhyAct_Time']
df['ModActTimeDiff'] = df['ModPhyAct_TimePost'] - df['ModPhyAct_Time']
df['MildActTimeDiff'] = df['MildPhyAct_TimePost'] - df['MildPhyAct_Time']

"""### DROP COLS NOT USEFUL"""

# Drop columns that are not useful anymore
df = df.drop(['VigPhyAct_TimePost', 'VigPhyAct_Time', 'ModPhyAct_TimePost', 'ModPhyAct_Time',
              'MildPhyAct_TimePost','MildPhyAct_Time', 'VigPhyAct_DaysPost', 'VigPhyAct_Days', 'ModPhyAct_DaysPost',
              'ModPhyAct_Days', 'MildPhyAct_DaysPost','MildPhyAct_Days', 'VigActDiff', 'VigActTimeDiff', 'ModActTimeDiff'], axis = 1)

"""### CONVERT TO FLOAT"""

# Convert strange values as nan
nansDict = {' ': np.nan,
            '': np.nan}

df['CHAOStot'] = df['CHAOStot'].replace(nansDict)

# Columns into float
cols = ['age_year', 'spq22', 'RPQtot', 'CASEStot', 'PHQtot',
        'GADtot', 'BeliefTot', 'ModActDiff', 'MildActDiff',
        'LoneTot','SleepTot', 'CHAOStot', 'MildActTimeDiff']

for col in cols:
    df[col] = df[col].astype(float)

df.to_csv(PROCESSED + 'covid_processed.csv')
