from local_config import ROOT_DATADIR
import os
import pandas as pd
from scipy import stats

#%% SELECT WAVE, DATASET, AND VARIABLE OF INTEREST
WAVE = 'wave1'
DATASETNAME = 'Week_UK'
TARGET = 'GADtot' #Depressive symptoms

DATASETDIR = os.path.join(ROOT_DATADIR, 'datasets', WAVE, DATASETNAME)
DATAFILE = os.path.join(DATASETDIR, 'data.csv')
#%% LOAD DATA
features = pd.read_csv(DATAFILE, index_col=0)

#remove rows with nans
features.dropna(axis=0, inplace=True)

# keep participants who completed the survey before week 10
features.query('label < 10', inplace=True)

#%%
#selecting the groups
print(features[[TARGET, 'label']])

#Divide participants into groups by week
third_week = features.loc[features['label'] == 3, TARGET]
fourth_week = features.loc[features['label'] == 4, TARGET]
fifth_week = features.loc[features['label'] == 5, TARGET]
sixth_week = features.loc[features['label'] == 6, TARGET]
seventh_week = features.loc[features['label'] == 7, TARGET]
eight_week = features.loc[features['label'] == 8, TARGET]
ninth_week = features.loc[features['label'] == 9, TARGET]

#%%  multipair Kruskal-Wallis tests (UK)
print('multiple comparison')
#For analysis on wave 1 uncomment the follwing code:
#print(stats.kruskal(third_week, fourth_week, fifth_week, sixth_week, seventh_week))

#For analysis on wave 2 uncomment the follwing code:
#print(stats.kruskal(third_week, fourth_week, fifth_week, sixth_week, ninth_week))

#%% POST-HOC TEST
#Bonferroni's correction (alpha = 0.05/4 = 0.0125)
print('posthoc seventh week vs others')

print(stats.kruskal(seventh_week, third_week))

print(stats.kruskal(seventh_week, fourth_week))

print(stats.kruskal(seventh_week, fifth_week))

print(stats.kruskal(seventh_week, sixth_week))
